<?php

/**
 * inf_gen_contrato actions.
 *
 * @package    contratacion
 * @subpackage inf_gen_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_gen_contratoActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'ORDER BY
tab0.id_anhos,
tab0.no_contrato,
tab0.clase_contrato';
        }


        /*
         * Manejo de errores
         */
        try {


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            $whereArea = "";
            $whereContratista = "";
            $whereContrato = "";
            $whereSupervisor = "";
            $whereTipoContrato = "";
            $whereTipoConvenio = "";

            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_area=" . $request['id_area'];
            }

            if (isset($request['id_contratista'])) {
                $whereContratista = " AND tab0.id_contratista=" . $request['id_contratista'];
            }

            if (isset($request['no_contrato'])) {
                $whereContrato = " AND tab0.no_contrato=" . $request['no_contrato'];
            }

            if (isset($request['id_supervisor'])) {
                $whereSupervisor = " AND tab0.id_supervisor=" . $request['id_supervisor'];
            }

            if (isset($request['id_tipo_contrato'])) {
                $whereTipoContrato = " AND tab0.id_tipo_contrato=" . $request['id_tipo_contrato'];
            }

            if (isset($request['id_tipo_convenio'])) {
                $whereTipoConvenio = " AND tab0.id_tipo_convenio=" . $request['id_tipo_convenio'];
            }


            /*
             * 
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
    
case when tipo_contrato is not null then tipo_contrato else tipo_convenio end as tipo_contrato_convenio,   
tab0.*

from(

    select 
    tab0.*,
    tab3.FECHA_INICIO,
    tab3.FECHA_TERMINACION,
    tab2.area,
    tab2.id_area,
    tab2.id_abogado,
    tab2.abogado,
    tab2.no_proceso,
    tab2.proceso as proceso_ep,
    /* Clase de contrato, si tiene registro de id_tipo_contrato y caarta de aceptacion es 0 es general, sino es de aceptacion, si tiene tipo conveio, es de conterato de convenio */
    case 
    when tab0.id_tipo_contrato is not null and tab0.carta_aceptacion = 0 then 'CONTRATO GENERAL'
    when tab0.id_tipo_contrato is not null and tab0.carta_aceptacion = 1 then 'CARTA DE ACEPTACIÓN'
    else 'CONVENIO' end as clase_contrato
    
    from co_contrato_v tab0
    
    join co_seleccion_ep tab1 
    ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
    
    join co_estudios_previos_v tab2 
    ON tab2.id_estudios_previos = tab1.id_estudios_previos
    
    left join (select id_contrato, max(fecha_terminacion) as fecha_terminacion, min(fecha_inicio) as fecha_inicio from co_legaliza_contrato group by id_contrato)tab3  ON tab3.id_contrato = tab0.id_contrato

)tab0
                    
where 
1 = 1
and tab0.FECHA_CONTRATO between to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')

$whereArea
$whereContratista
$whereContrato
$whereSupervisor
$whereTipoContrato
$whereTipoConvenio

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
                    
case when tipo_contrato is not null then tipo_contrato else tipo_convenio end as tipo_contrato_convenio,   
tab0.*                    

from(

    select 
    tab0.*,
    tab3.FECHA_INICIO,
    tab3.FECHA_TERMINACION,
    tab2.area,
    tab2.id_area,
    tab2.id_abogado,
    tab2.abogado,
    tab2.no_proceso,
    tab2.proceso as proceso_ep,
    /* Clase de contrato, si tiene registro de id_tipo_contrato y caarta de aceptacion es 0 es general, sino es de aceptacion, si tiene tipo conveio, es de conterato de convenio */
    case 
    when tab0.id_tipo_contrato is not null and tab0.carta_aceptacion = 0 then 'CONTRATO GENERAL'
    when tab0.id_tipo_contrato is not null and tab0.carta_aceptacion = 1 then 'CARTA DE ACEPTACIÓN'
    else 'CONVENIO' end as clase_contrato
    
    from co_contrato_v tab0
    
    join co_seleccion_ep tab1 
    ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
    
    join co_estudios_previos_v tab2 
    ON tab2.id_estudios_previos = tab1.id_estudios_previos
    
    left join (select id_contrato, max(fecha_terminacion) as fecha_terminacion, min(fecha_inicio) as fecha_inicio from co_legaliza_contrato group by id_contrato)tab3  ON tab3.id_contrato = tab0.id_contrato

)tab0
                    
where 
1 = 1
and tab0.FECHA_CONTRATO between to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')

$whereArea
$whereContratista
$whereContrato
$whereSupervisor
$whereTipoContrato
$whereTipoConvenio
                    
$sortBy                    
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_gen_contrato] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
